"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Memory storage. Allows to replace use of localStorage and sessionStorage
 * with an in-memory storage that implements the same interface.
 * https://github.com/RobertoPrevato/KingTable
 *
 * Copyright 2018, Roberto Prevato
 * https://robertoprevato.github.io
 *
 * Licensed under the MIT license:
 * http://www.opensource.org/licenses/MIT
 */

var CACHE = {};

exports.default = {
  items: function items() {
    return CACHE;
  },
  length: function length() {
    var x,
        i = 0;
    for (x in CACHE) {
      i++;
    }
    return i;
  },
  getItem: function getItem(name) {
    return CACHE[name];
  },
  setItem: function setItem(name, value) {
    CACHE[name] = value;
  },
  removeItem: function removeItem(name) {
    delete CACHE[name];
  },
  clear: function clear() {
    var x;
    for (x in CACHE) {
      delete CACHE[x];
    }
  }
};