"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Object analyzer.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * https://github.com/RobertoPrevato/KingTable
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright 2018, Roberto Prevato
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * https://robertoprevato.github.io
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Licensed under the MIT license:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * http://www.opensource.org/licenses/MIT
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _utils = require("../../scripts/utils");

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Analyzer = function () {
  function Analyzer() {
    _classCallCheck(this, Analyzer);
  }

  _createClass(Analyzer, [{
    key: "describe",


    /**
     * Returns an object describing the properties of a given item.
     * @return {object}
     */
    value: function describe(o, options) {
      if (_utils2.default.isArray(o)) return this.describeList(o, options);
      var schema = {},
          x;
      for (x in o) {
        schema[x] = this.getType(o[x]);
      }
      return schema;
    }

    /**
     * Returns an object describing the properties of the items contained by a list.
     * @return {object}
     */

  }, {
    key: "describeList",
    value: function describeList(a, options) {
      var schema = {};
      options = options || {};
      function typ(o) {
        return o; // TODO: refactor to return object with "nullable" info?
      }
      var l = _utils2.default.isNumber(options.limit) ? options.limit : a.length;
      for (var i = 0; i < l; i++) {
        var o = this.describe(a[i]);
        for (var x in o) {
          if (_utils2.default.has(schema, x)) {
            //compare
            if (typ(o[x]) != undefined && typ(schema[x]) != typ(o[x])) {
              if (!typ(schema[x])) {
                schema[x] = typ(o[x]);
              } else {
                //force string type
                schema[x] = "string";
              }
            }
          } else {
            // add new  property
            _utils2.default.extend(schema, o);
          }
        }
        if (options.lazy && !_utils2.default.any(schema, function (k, v) {
          return v === undefined;
        })) {
          break;
        }
      }
      return schema;
    }

    /**
     * Returns a string representing a type, in greater detail than normal JS.
     * @return {string}
     */

  }, {
    key: "getType",
    value: function getType(o) {
      if (o == null || o == undefined) return;
      if (o instanceof Array) return "array";
      if (o instanceof Date) return "date";
      if (o instanceof RegExp) return "regex";
      return typeof o === "undefined" ? "undefined" : _typeof(o);
    }
  }]);

  return Analyzer;
}();

exports.default = Analyzer;