"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextSlider = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Text slider.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * https://github.com/RobertoPrevato/KingTable
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright 2018, Roberto Prevato
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * https://robertoprevato.github.io
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Licensed under the MIT license:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * http://www.opensource.org/licenses/MIT
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _utils = require("../../scripts/utils");

var _utils2 = _interopRequireDefault(_utils);

var _exceptions = require("../../scripts/exceptions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TextSlider = function () {
  function TextSlider(text, filler) {
    _classCallCheck(this, TextSlider);

    if (!text) (0, _exceptions.ArgumentNullException)("text");
    this.length = text.length;
    this.i = 0;
    this.j = this.length;
    this.text = text;
    this.filler = filler || " ";
    this.right = true;
  }

  /**
   * Resets this TextSlider at its initial statte.
   */


  _createClass(TextSlider, [{
    key: "reset",
    value: function reset() {
      this.i = 0;
      this.j = this.length;
      this.right = true;
    }
  }, {
    key: "next",
    value: function next() {
      var self = this,
          s = self.text,
          filler = self.filler,
          length = self.length,
          i = self.i,
          j = self.j,
          right = self.right;
      var a = s.substr(i, j);
      var change = false;
      if (right) {
        if (j == 1) {
          j = s.length;
          i = j;
          change = true;
        } else {
          j--;
        }
      } else {
        if (i == 0) {
          j--;
          change = true;
        } else {
          i--;
        }
      }

      if (right && s.length != a.length) {
        a = new Array(s.length - a.length + 1).join(filler) + a;
      } else {
        a = a + new Array(s.length - a.length + 1).join(filler);
      }
      if (change) {
        right = !right;
        self.right = right;
      }
      self.i = i;
      self.j = j;
      return a;
    }
  }]);

  return TextSlider;
}();

exports.TextSlider = TextSlider;