"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = require("../../scripts/utils");

var _utils2 = _interopRequireDefault(_utils);

var _string = require("../../scripts/components/string");

var _string2 = _interopRequireDefault(_string);

var _html = require("../../scripts/data/html");

var _kingtable = require("../../scripts/tables/kingtable.builder");

var _kingtable2 = _interopRequireDefault(_kingtable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * KingTable base HTML builder.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Base class for all HTML builders.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://github.com/RobertoPrevato/KingTable
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018, Roberto Prevato
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://robertoprevato.github.io
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the MIT license:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * http://www.opensource.org/licenses/MIT
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var KingTableBaseHtmlBuilder = function (_KingTableBuilder) {
  _inherits(KingTableBaseHtmlBuilder, _KingTableBuilder);

  function KingTableBaseHtmlBuilder() {
    _classCallCheck(this, KingTableBaseHtmlBuilder);

    return _possibleConstructorReturn(this, (KingTableBaseHtmlBuilder.__proto__ || Object.getPrototypeOf(KingTableBaseHtmlBuilder)).apply(this, arguments));
  }

  _createClass(KingTableBaseHtmlBuilder, [{
    key: "getItemAttrObject",


    /**
     * Returns an attribute object for an HTML element related to an item.
     * 
     * @param {int} ix 
     */
    value: function getItemAttrObject(ix, item) {
      var o = this.options,
          deco = o && o.itemDecorator;
      var attr = {
        "class": "kt-item",
        "data-item-ix": ix // item index among currently displayed items
      };
      if (deco) {
        var re = deco.call(this, item);
        // TODO: merge class or css option
        return _utils2.default.extend(attr, re);
      }
      return attr;
    }

    /**
     * Produces a fragment of HTML to highligh a pattern inside a text.
     *
     * @param {string} text: text from which to produce an HTML fragment.
     * @param {RegExp} pattern: search pattern.
     */

  }, {
    key: "highlight",
    value: function highlight(text, pattern) {
      if (!text) return "";
      if (!(pattern instanceof RegExp)) {
        // obtain from table
        var table = this.table;
        var pattern = table.searchText ? table.filters.getRuleByKey("search").value : null;
        if (!pattern) return text;
      }

      var diacritics = _string2.default.findDiacritics(text);
      var hasDiacritics = diacritics.length,
          textWithoutDiacritics;

      if (hasDiacritics) {
        // remove diacritics before finding matches
        textWithoutDiacritics = _string2.default.normalize(text);
      } else {
        textWithoutDiacritics = text;
      }
      // find all matches at their index, this is required to properly escape html characters
      var matches = [];
      textWithoutDiacritics.replace(pattern, function (value) {
        var index = arguments[arguments.length - 2];
        // NB: if the string contained diacritics, we need to restore
        // only those that appeared in the same place of the original string
        matches.push({
          i: index,
          val: hasDiacritics ? _string2.default.restoreDiacritics(value, diacritics, index) : value // put back diacritics where they were
        });
      });

      var s = "",
          j = 0,
          m,
          val;
      for (var i = 0, l = matches.length; i < l; i++) {
        m = matches[i];
        val = m.val;
        var portion = text.substring(j, m.i);
        s += (0, _html.escapeHtml)(portion); // escape the portion that is outside of the highlight
        j = m.i + val.length;
        s += "<span class=\"kt-search-highlight\">" + (0, _html.escapeHtml)(val) + "</span>";
      }
      if (j < text.length) {
        s += (0, _html.escapeHtml)(text.substr(j));
      }
      return s;
    }
  }]);

  return KingTableBaseHtmlBuilder;
}(_kingtable2.default);

exports.default = KingTableBaseHtmlBuilder;