"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _html = require("../../scripts/data/html");

var _kingtableHtmlBase = require("../../scripts/tables/kingtable.html.base.builder");

var _kingtableHtmlBase2 = _interopRequireDefault(_kingtableHtmlBase);

var _raise = require("../../scripts/raise");

var _raise2 = _interopRequireDefault(_raise);

var _utils = require("../../scripts/utils");

var _utils2 = _interopRequireDefault(_utils);

var _dom = require("../../scripts/dom");

var _dom2 = _interopRequireDefault(_dom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * KingTable bare HTML builder.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Renders tabular data in HTML format, without event handlers.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Suitable for web pages and emails.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://github.com/RobertoPrevato/KingTable
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018, Roberto Prevato
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://robertoprevato.github.io
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the MIT license:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * http://www.opensource.org/licenses/MIT
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var SPACE = " ";

var KingTableHtmlBuilder = function (_KingTableBaseHtmlBui) {
  _inherits(KingTableHtmlBuilder, _KingTableBaseHtmlBui);

  /**
   * Creates a new instance of KingTableHtmlBuilder associated with the given table.
   */
  function KingTableHtmlBuilder(table) {
    _classCallCheck(this, KingTableHtmlBuilder);

    var _this = _possibleConstructorReturn(this, (KingTableHtmlBuilder.__proto__ || Object.getPrototypeOf(KingTableHtmlBuilder)).call(this, table));

    _this.options = _utils2.default.extend({}, table ? table.options : null);
    _this.setListeners();
    return _this;
  }

  /**
   * Global options for every KingTableHtmlBuilder.
   */


  _createClass(KingTableHtmlBuilder, [{
    key: "setListeners",


    /**
     * Sets listeners for the given table.
     */
    value: function setListeners() {
      var self = this;
      var table = self.table;
      if (!table || !table.element) return self;

      self.listenTo(table, {
        "fetching:data": function fetchingData() {
          self.loadingHandler();
        },
        "fetched:data": function fetchedData() {
          self.unsetLoadingHandler();
        },
        "fetch:fail": function fetchFail() {
          self.unsetLoadingHandler().display(self.errorView());
        },
        "no-results": function noResults() {
          self.unsetLoadingHandler().display(self.emptyView());
        }
      });
    }

    /**
     * Gets auto-generated fields by options.
     */

  }, {
    key: "getGeneratedFields",
    value: function getGeneratedFields() {
      var o = this.options,
          reg = this.getReg(),
          detailRoute = o.detailRoute,
          a = [],
          goToDetails = reg.goToDetails;

      if (detailRoute) {
        if (!/\/$/.test(detailRoute)) {
          detailRoute = o.detailRoute = detailRoute + "/";
        }
        // Following could cause exception if id property cannot be determined automatically
        var idProperty = this.table.getIdProperty();

        a.push({
          name: "details-link",
          html: function html(item) {
            var itemDetailRoute = detailRoute + item[idProperty];
            return "<a class='kt-details-link' href='" + itemDetailRoute + "'>" + goToDetails + "</a>";
          }
        });
      }
      return a;
    }

    /**
     * Gets the fields to be displayed.
     * Fields comprises objects properties and extra information for every item.
     */

  }, {
    key: "getFields",
    value: function getFields() {
      var table = this.table;
      var fields = _utils2.default.clone(table.columns),
          o = this.options,
          itemCount = o.itemCount,
          generatedFields = this.getGeneratedFields(),
          countField = itemCount ? {
        name: "ε_row",
        displayName: "#"
      } : null;

      if (countField) {
        fields.unshift(countField);
      }

      // allow extending the table with extra fields
      var extraFields = o.fields;
      if (extraFields) {
        if (_utils2.default.isFunction(extraFields)) {
          extraFields = extraFields.call(this, fields);
        }
        fields = generatedFields.concat(extraFields.concat(fields));
      } else {
        fields = generatedFields.concat(fields);
      }
      return fields;
    }

    /**
     * Builds the given instance of KingTable in HTML.
     */

  }, {
    key: "build",
    value: function build() {
      var self = this;
      var table = self.table;
      var data = table.getData({
        format: true,
        hide: false
      });
      if (!data || !data.length) {
        return self.display(self.emptyView());
      }
      var fields = self.getFields();
      var caption = self.buildCaption();
      var view = self.buildView(fields, data);
      var root = self.buildRoot(caption, view);
      self.display(root);
    }

    /**
     * Builds a root virtual element for the given table, with given
     * table children.
     */

  }, {
    key: "buildRoot",
    value: function buildRoot(caption, view) {
      var table = this.table;
      var rootAttr = {
        "class": "king-table-region"
      };
      if (table.id) {
        rootAttr.id = table.id;
      }
      return new _html.VHtmlElement("div", rootAttr, [caption, view]);
    }

    /**
     * Builds a default view.
     */

  }, {
    key: "buildView",
    value: function buildView(fields, data) {
      var table = this.table;
      return new _html.VHtmlElement("table", {
        "class": "king-table"
      }, [this.buildHead(fields), this.buildBody(fields, data)]);
    }

    /**
     * Builds a header.
     */

  }, {
    key: "buildHead",
    value: function buildHead(fields) {
      var table = this.table;
      var row = new _html.VHtmlElement("tr", {}, _utils2.default.map(_utils2.default.values(fields), function (prop) {
        if (prop.hidden || prop.secret) {
          return; // skip
        }
        return new _html.VHtmlElement("th", { "class": prop.css }, new _html.VTextElement(prop.displayName));
      }));
      return new _html.VHtmlElement("thead", { "class": "king-table-head" }, row);
    }

    /**
     * Builds a table body in HTML from given table and data.
     */

  }, {
    key: "buildBody",
    value: function buildBody(fields, data) {
      var _this2 = this;

      var table = this.table,
          builder = table.builder,
          formattedSuffix = table.options.formattedSuffix,
          searchPattern = table.searchText ? table.filters.getRuleByKey("search").value : null,
          autoHighlight = table.options.autoHighlightSearchProperties;
      // at every table build, assign an id to the represented item
      var ix = -1;
      var rows = _utils2.default.map(data, function (item) {
        ix += 1;
        item.__ix__ = ix;
        var cells = [],
            x,
            col;
        for (var i = 0, l = fields.length; i < l; i++) {
          col = fields[i];
          x = col.name;
          if (col.hidden || col.secret) {
            continue;
          }
          var formattedProp = x + formattedSuffix;

          var valueEl,
              value = _utils2.default.has(item, formattedProp) ? item[formattedProp] : item[x];

          // does the column define an html resolver?
          if (col.html) {
            if (!_utils2.default.isFunction(col.html)) {
              (0, _raise2.default)(24, "Invalid 'html' option for property, it must be a function.");
            }
            // NB: it is responsibility of the user of the library to escape HTML characters that need to be escaped
            var html = col.html.call(builder, item, value);
            valueEl = new _html.VHtmlFragment(html || "");
          } else {
            if (value === null || value === undefined || value === "") {
              valueEl = new _html.VTextElement("");
            } else {
              // is a search active?
              if (searchPattern && autoHighlight && _utils2.default.isString(value)) {
                // an html fragment is required to display an highlighted value
                valueEl = new _html.VHtmlFragment(builder.highlight(value, searchPattern));
              } else {
                valueEl = new _html.VTextElement(value);
              }
            }
          }

          cells.push(new _html.VHtmlElement("td", col ? {
            "class": col.css || col.name
          } : {}, valueEl));
        }
        return new _html.VHtmlElement("tr", _this2.getItemAttrObject(ix, item), cells);
      });
      return new _html.VHtmlElement("tbody", { "class": "king-table-body" }, rows);
    }

    /**
     * Returns a caption element for the given table.
     */

  }, {
    key: "buildCaption",
    value: function buildCaption() {
      var table = this.table;
      var caption = table.options.caption;
      var paginationInfo = KingTableHtmlBuilder.options.paginationInfo ? this.buildPaginationInfo() : null;
      return caption || paginationInfo ? new _html.VHtmlElement("div", {
        "class": "king-table-caption"
      }, [caption ? new _html.VHtmlElement("span", {}, new _html.VTextElement(caption)) : null, paginationInfo ? caption ? new _html.VHtmlElement("br") : null : null, paginationInfo]) : null;
    }

    /**
     * Returns pagination information about the given table.
     */

  }, {
    key: "buildPaginationInfo",
    value: function buildPaginationInfo() {
      var table = this.table;
      var data = table.pagination,
          reg = this.getReg(),
          page = data.page,
          totalPageCount = data.totalPageCount,
          resultsPerPage = data.resultsPerPage,
          firstObjectNumber = data.firstObjectNumber,
          lastObjectNumber = data.lastObjectNumber,
          totalItemsCount = data.totalItemsCount,
          dataAnchorTime = table.getFormattedAnchorTime(),
          isNum = _utils2.default.isNumber;
      // render simply pagination information,
      // since event handlers are out of the scope of this class
      var s = "",
          sep = " - ";
      if (isNum(page)) {
        s += reg.page + SPACE + page;

        if (isNum(totalPageCount) && totalPageCount > 0) {
          s += SPACE + reg.of + SPACE + totalPageCount;
        }

        if (isNum(firstObjectNumber) && isNum(lastObjectNumber) && lastObjectNumber > 0) {
          s += sep + reg.results + (" " + firstObjectNumber + " - " + lastObjectNumber);
          if (isNum(totalItemsCount)) {
            s += " " + reg.of + " - " + totalItemsCount;
          }
        }
      }
      if (dataAnchorTime && table.options.showAnchorTimestamp) {
        s += sep + (reg.anchorTime + " " + dataAnchorTime);
      }
      var paginationInfo = new _html.VHtmlElement("span", {
        "class": "pagination-info"
      }, new _html.VTextElement(s));
      return paginationInfo;
    }
  }, {
    key: "emptyView",
    value: function emptyView(bare) {
      var reg = this.getReg();
      var el = new _html.VHtmlElement("div", { "class": "king-table-empty" }, new _html.VHtmlElement("span", 0, new _html.VTextElement(reg.noData)));
      return bare ? el : this.singleLine(this.table, el);
    }
  }, {
    key: "errorView",
    value: function errorView(message) {
      if (!message) {
        message = this.getReg().errorFetchingData;
      }
      return this.singleLine(this.table, new _html.VHtmlFragment("<div class=\"king-table-error\">\n      <span class=\"message\">\n        <span>" + message + "</span>\n        <span class=\"oi\" data-glyph=\"warning\" aria-hidden=\"true\"></span>\n      </span>\n    </div>"));
    }
  }, {
    key: "loadingView",
    value: function loadingView() {
      var table = this.table;
      var reg = this.getReg();
      var caption = this.buildCaption();
      caption.children.push(new _html.VHtmlElement("div", {
        "class": "loading-info"
      }, [new _html.VHtmlElement("span", {
        "class": "loading-text"
      }, new _html.VTextElement(reg.loading)), new _html.VHtmlElement("span", {
        "class": "mini-loader"
      })]));
      return this.buildRoot([caption]);
    }

    /**
     * Displays a built table.
     */

  }, {
    key: "display",
    value: function display(built) {
      var table = this.table;
      // If a table has an element, assume that is a DOM element;
      if (!_utils2.default.isString(built)) built = built.toString();
      //
      // NB: aside from this piece of code, this class is abstracted
      // from DOM manipulation;
      // If a table has an element, assume that is a DOM element;
      //
      var element = table.element;
      if (element) {
        //
        // NB: this class does not set any event handler,
        // hence does not try to unset any event handler when removing an element.
        //
        // a custom event is fired, so the user of the library can unset any event added
        // by other means (e.g. vanilla JavaScript or jQuery)
        //
        element.classList.add("king-table");
        table.emit("empty:element", element);
        while (element.hasChildNodes()) {
          element.removeChild(element.lastChild);
        }
        element.innerHTML = built;
      }
    }

    /**
     * Returns an information for the table in a single line, including
     * table caption and pagination information, if available.
     */

  }, {
    key: "singleLine",
    value: function singleLine(line) {
      var table = this.table;
      var caption = this.buildCaption();
      caption.children.push(new _html.VHtmlElement("br"), new _html.VHtmlElement("div", {
        "class": "loading-info"
      }, _utils2.default.isString(line) ? new _html.VTextElement(line) : line));
      return this.buildRoot([caption]);
    }
  }, {
    key: "loadingHandler",
    value: function loadingHandler() {
      var self = this,
          table = self.table;
      self.unsetLoadingHandler();

      var delayInfo = table.hasData() ? KingTableHtmlBuilder.options.loadInfoDelay : 0;
      // display a loading information, but only if waiting for more than n milliseconds
      self.showLoadingTimeout = setTimeout(function () {
        if (!table.loading) {
          return self.unsetLoadingHandler();
        }
        self.display(self.loadingView());
      }, delayInfo);
    }
  }, {
    key: "unsetLoadingHandler",
    value: function unsetLoadingHandler() {
      clearTimeout(this.showLoadingTimeout);
      this.showLoadingTimeout = null;
      return this;
    }

    /**
     * Disposes of this KingTableHtmlBuilder.
     */

  }, {
    key: "dispose",
    value: function dispose() {
      var table = this.table;
      var element = table.element;
      if (element) {
        _dom2.default.empty(element);
      }
      this.stopListening(this.table);
      this.table = null;
      delete this.options;
    }
  }], [{
    key: "options",
    get: function get() {
      return {
        handleLoadingInfo: true, // whether to display loading information (suitable for console applications)
        loadInfoDelay: 500, // how many milliseconds should wait, before displaying the "Loading..." information
        paginationInfo: true // whether to show pagination info or not
      };
    }
  }]);

  return KingTableHtmlBuilder;
}(_kingtableHtmlBase2.default);

exports.default = KingTableHtmlBuilder;