"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _html = require("../../scripts/data/html");

var _kingtableMenu = require("../../scripts/menus/kingtable.menu.html");

var _kingtableMenu2 = _interopRequireDefault(_kingtableMenu);

var _kingtableHtml = require("../../scripts/tables/kingtable.html.builder");

var _kingtableHtml2 = _interopRequireDefault(_kingtableHtml);

var _kingtableHtmlBase = require("../../scripts/tables/kingtable.html.base.builder");

var _kingtableHtmlBase2 = _interopRequireDefault(_kingtableHtmlBase);

var _kingtable = require("../../scripts/menus/kingtable.menu");

var _kingtable2 = _interopRequireDefault(_kingtable);

var _raise = require("../../scripts/raise");

var _raise2 = _interopRequireDefault(_raise);

var _utils = require("../../scripts/utils");

var _utils2 = _interopRequireDefault(_utils);

var _dom = require("../../scripts/dom");

var _dom2 = _interopRequireDefault(_dom);

var _file = require("../../scripts/data/file");

var _file2 = _interopRequireDefault(_file);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * KingTable rich HTML builder.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Renders tabular data in HTML format, with event handlers and tools.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Suitable for web pages and desktop applications powered by Node.js.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://github.com/RobertoPrevato/KingTable
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018, Roberto Prevato
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://robertoprevato.github.io
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the MIT license:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * http://www.opensource.org/licenses/MIT
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


// import xml from "../../scripts/data/xml"
var SPACE = " ";
var CHECKBOX_TYPE = "checkbox";
var KingTableClassName = "king-table";

function classObj(name) {
  return { "class": name };
}

/**
 * Default methods to build a Gallery view for KingTableRichHtmlBuilder.
 * NB: functions are executed in the context of the KingTableRichHtmlBuilder.
 */

var KingTableRhGalleryViewResolver = function (_KingTableBaseHtmlBui) {
  _inherits(KingTableRhGalleryViewResolver, _KingTableBaseHtmlBui);

  function KingTableRhGalleryViewResolver() {
    _classCallCheck(this, KingTableRhGalleryViewResolver);

    return _possibleConstructorReturn(this, (KingTableRhGalleryViewResolver.__proto__ || Object.getPrototypeOf(KingTableRhGalleryViewResolver)).apply(this, arguments));
  }

  _createClass(KingTableRhGalleryViewResolver, [{
    key: "buildView",
    value: function buildView(table, columns, data) {
      return new _html.VHtmlElement("div", classObj("king-table-gallery"), [this.buildBody(table, columns, data), new _html.VHtmlElement("br", classObj("break"))]);
    }

    /**
     * Builds a table body in HTML from given table and data.
     */

  }, {
    key: "buildBody",
    value: function buildBody(table, columns, data) {
      var builder = this,
          formattedSuffix = table.options.formattedSuffix,
          searchPattern = table.searchText ? table.filters.getRuleByKey("search").value : null,
          autoHighlight = table.options.autoHighlightSearchProperties;
      var ix = -1;
      var rows = _utils2.default.map(data, function (item) {
        ix += 1;
        item.__ix__ = ix;
        var cells = [],
            x,
            col;
        for (var i = 0, l = columns.length; i < l; i++) {
          col = columns[i];
          x = col.name;
          if (col.hidden || col.secret) {
            continue;
          }
          var formattedProp = x + formattedSuffix;
          var valueEl,
              value = _utils2.default.has(item, formattedProp) ? item[formattedProp] : item[x];

          // does the column define an html resolver?
          if (col.html) {
            if (!_utils2.default.isFunction(col.html)) {
              (0, _raise2.default)(24, "Invalid 'html' option for property");
            }
            // NB: it is responsibility of the user of the library to escape HTML characters that need to be escaped
            var html = col.html.call(builder, item, value);
            valueEl = new _html.VHtmlFragment(html || "");
          } else {
            if (value === null || value === undefined || value === "") {
              valueEl = new _html.VTextElement("");
            } else {
              // is a search active?
              if (searchPattern && autoHighlight && _utils2.default.isString(value)) {
                // an html fragment is required to display an highlighted value
                valueEl = new _html.VHtmlFragment(builder.highlight(value, searchPattern));
              } else {
                valueEl = new _html.VTextElement(value);
              }
            }
          }

          cells.push(new _html.VHtmlElement(col.name == "ε_row" ? "strong" : "span", col ? {
            "class": col.css || col.name,
            "title": col.displayName
          } : {}, valueEl));
        }
        return new _html.VHtmlElement("li", builder.getItemAttrObject(ix, item), cells);
      });
      return new _html.VHtmlElement("ul", { "class": "king-table-body" }, rows);
    }
  }]);

  return KingTableRhGalleryViewResolver;
}(_kingtableHtmlBase2.default);

var SortModes = {
  Simple: "simple", // only one property at a time;
  Complex: "complex" // sort by multiple properties;


  /**
   * Normalizes
   */
};function normalizeExtraView(o) {
  if (!o) (0, _raise2.default)(34, "Invalid extra view configuration.");
  if (!o.name) (0, _raise2.default)(35, "Missing name in extra view configuration.");

  if (o.getItemTemplate) {
    _utils2.default.extend(o, {
      resolver: {
        getItemTemplate: o.getItemTemplate,

        buildView: function buildView(table, columns, data) {
          var itemTemplate = this.getItemTemplate();
          if (!itemTemplate) {
            (0, _raise2.default)(31, "Invalid getItemTemplate function in extra view.");
          }
          var rows = _utils2.default.map(data, function (datum) {
            var html = itemTemplate.replace(/\{\{(.+?)\}\}/g, function (s, a) {
              if (!datum.hasOwnProperty(a)) (0, _raise2.default)(32, "Missing property " + a + ", for template");
              return table.getItemValue(datum, a);
            });
            return new _html.VHtmlFragment(html);
          });
          return new _html.VHtmlElement("div", { "class": ("king-table-body " + o.name).toLowerCase() }, rows);
        }
      }
    });
    delete o.getItemTemplate;
  }
  return o;
}

var KingTableRichHtmlBuilder = function (_KingTableHtmlBuilder) {
  _inherits(KingTableRichHtmlBuilder, _KingTableHtmlBuilder);

  /**
   * Creates a new instance of KingTableRichHtmlBuilder associated with the given table.
   */
  function KingTableRichHtmlBuilder(table) {
    _classCallCheck(this, KingTableRichHtmlBuilder);

    var _this2 = _possibleConstructorReturn(this, (KingTableRichHtmlBuilder.__proto__ || Object.getPrototypeOf(KingTableRichHtmlBuilder)).call(this, table));

    _this2.options = _utils2.default.extend({}, KingTableRichHtmlBuilder.defaults, table.options, table.options.rhtml || table.options.html);
    _this2.setSeachHandler();

    var options = _this2.options,
        extraViews = options.extraViews;
    if (extraViews) {
      options.views = options.views.concat(_utils2.default.map(extraViews, function (o) {
        return normalizeExtraView(o);
      }));
    }

    // load settings from stores
    _this2.loadSettings();

    // initialize global menu event handlers
    if (!_kingtable2.default.initialized) {
      _kingtable2.default.setup();
    }

    _this2.filtersViewOpen = options.filtersView && options.filtersViewExpandable && options.filtersViewOpen;
    return _this2;
  }

  _createClass(KingTableRichHtmlBuilder, [{
    key: "setListeners",
    value: function setListeners() {
      var _this3 = this;

      _get(KingTableRichHtmlBuilder.prototype.__proto__ || Object.getPrototypeOf(KingTableRichHtmlBuilder.prototype), "setListeners", this).call(this);

      // additional listeners
      var self = this,
          table = self.table;
      if (!table || !table.element) return self;

      self.listenTo(table, {
        "change:pagination": function changePagination() {
          if (!_this3.rootElement) return true;
          self.updatePagination();
        },
        "get-list:failed": function getListFailed() {
          // pagination must be updated also in this case
          if (!_this3.rootElement) return true;
          self.updatePagination();
        }
      });
    }
  }, {
    key: "loadSettings",
    value: function loadSettings() {
      var self = this,
          o = self.options,
          table = self.table,
          store = table.getFiltersStore();
      if (!store) return self;

      // restore sort mode
      var storedSortMode = table.getPreference("sort-mode");
      if (storedSortMode) {
        o.sortMode = storedSortMode;
      }

      var storedViewType = table.getPreference("view-type");
      if (storedViewType) {
        o.view = storedViewType;
      }

      return self;
    }

    /**
     * Sets a client side search handler for the table.
     */

  }, {
    key: "setSeachHandler",
    value: function setSeachHandler() {
      var delay = this.options.searchDelay;
      function search(text) {
        var table = this.table;
        // set search, but only if the value is of sufficient length
        if (table.validateForSeach(text)) {
          // the value is sufficient to trigger a search
          table.search(text);
        } else if (table.isSearchActive()) {
          // unset search: the value is either too short or empty
          table.unsetSearch();
          table.render();
        }
        table.getFiltersSetCache(); // store filter in cache
        // continue normally
        return true;
      }

      this.search = _utils2.default.isNumber(delay) && delay > 0 ? _utils2.default.debounce(search, delay, this) : search;
      return this;
    }

    /**
     * Gets the view resolver currently used by this KingTableRichHtmlBuilder,
     * with validation.
     */

  }, {
    key: "getViewResolver",
    value: function getViewResolver() {
      var o = this.options,
          view = o.view,
          views = o.views;
      if (!_utils2.default.isString(view)) {
        (0, _raise2.default)(21, "Missing view configuration for Rich HTML builder");
      }
      var viewData = _utils2.default.find(views, function (v) {
        return v.name == view;
      });
      if (!viewData) {
        (0, _raise2.default)(22, "Missing view resolver for view: " + view);
      }
      var resolver = viewData.resolver;
      if (resolver === true) {
        // use the default functions
        return this;
      }
      if (!resolver) (0, _raise2.default)(33, "Missing resolver in view configuration '" + view + "'");

      // support both instantiable objects and plain objects
      if (!_utils2.default.isPlainObject(resolver)) resolver = new resolver();

      if (!_utils2.default.quacks(resolver, ["buildView"])) {
        (0, _raise2.default)(23, "Invalid resolver for view: " + view);
      }
      return resolver;
    }

    /**
     * Returns a caption element for the given table.
     */

  }, {
    key: "buildCaption",
    value: function buildCaption() {
      var table = this.table;
      var caption = table.options.caption;
      return caption ? new _html.VHtmlElement("div", {
        "class": "king-table-caption"
      }, new _html.VHtmlElement("span", {}, new _html.VTextElement(caption))) : null;
    }

    /**
     * Builds the given instance of KingTable in HTML.
     */

  }, {
    key: "build",
    value: function build() {
      var self = this;
      var table = self.table;
      var element = table.element;
      if (!element) {
        // for this class, it doesn't make sense if a table doesn't have an element.
        // raise(25, "Missing table element"); //TODO: handle for tests
        return self;
      }
      return self.ensureLayout().update();
    }

    /**
     * Ensures that the HTML layout is ready to display the bound table.
     */

  }, {
    key: "ensureLayout",
    value: function ensureLayout() {
      var self = this;
      if (self.rootElement) {
        return self;
      }
      var table = self.table,
          o = self.options,
          element = table.element,
          view = self.buildView(null, null, new _html.VHtmlFragment(" ")),
          caption = self.buildCaption(),
          root = self.buildRoot(caption, view);
      table.emit("empty:element", element);
      _dom2.default.empty(element);
      _dom2.default.addClass(element, KingTableClassName);
      element.innerHTML = root.toString();
      // add reference to root element
      self.rootElement = _dom2.default.findFirstByClass(element, "king-table-region");
      // bind events
      self.bindEvents();

      _utils2.default.ifcall(o.onLayoutRender, self, [element]);
      if (o.filtersView) {
        _utils2.default.ifcall(o.onFiltersRender, self, [_dom2.default.findFirstByClass(element, "kt-filters")]);
      }
      return self;
    }

    /**
     * Updates the current rendered view to current table state.
     */

  }, {
    key: "update",
    value: function update() {
      this.updatePagination().updateView();
    }

    /**
     * Updates the current rendered pagination view to current table state.
     */

  }, {
    key: "updatePagination",
    value: function updatePagination() {
      var table = this.table,
          data = table.pagination,
          rootElement = this.rootElement;
      if (!rootElement) {
        (0, _raise2.default)(26, "missing root element");
      }
      var reg = this.getReg(),
          o = table.options,
          data = table.pagination,
          page = data.page,
          totalPageCount = data.totalPageCount,
          resultsPerPage = data.resultsPerPage,
          firstObjectNumber = data.firstObjectNumber,
          lastObjectNumber = data.lastObjectNumber,
          totalItemsCount = data.totalItemsCount,
          dataAnchorTime = table.getFormattedAnchorTime(),
          isNum = _utils2.default.isNumber,
          findByClass = _dom2.default.findFirstByClass,
          addClass = _dom2.default.addClass,
          removeClass = _dom2.default.removeClass;

      var pageEl = findByClass(rootElement, "pagination-bar-page-number");
      pageEl.value = page;

      var sizeEl = findByClass(rootElement, "pagination-bar-results-select");
      sizeEl.value = resultsPerPage;

      var a = "pagination-button",
          b = "pagination-button-disabled";
      _utils2.default.each(["pagination-bar-first-page", "pagination-bar-prev-page"], function (name) {
        var el = findByClass(rootElement, name);
        if (page > 1) {
          addClass(el, a);
          removeClass(el, b);
        } else {
          addClass(el, b);
          removeClass(el, a);
        }
      });

      _utils2.default.each(["pagination-bar-last-page", "pagination-bar-next-page"], function (name) {
        var el = findByClass(rootElement, name);
        if (page < totalPageCount) {
          addClass(el, a);
          removeClass(el, b);
        } else {
          addClass(el, b);
          removeClass(el, a);
        }
      });

      var resultsInfo = "";
      if (isNum(firstObjectNumber) && isNum(lastObjectNumber) && lastObjectNumber > 0) {
        resultsInfo += reg.results + (" " + firstObjectNumber + " - " + lastObjectNumber);
        if (isNum(totalItemsCount)) {
          resultsInfo += " " + reg.of + " - " + totalItemsCount;
        }
      }
      var anchorTimeInfo = "";
      if (dataAnchorTime && table.options.showAnchorTimestamp) {
        anchorTimeInfo = reg.anchorTime + " " + dataAnchorTime;
      }

      var info = {
        "results-info": resultsInfo,
        "anchor-timestamp-info": anchorTimeInfo,
        "total-page-count": reg.of + " " + totalPageCount
      },
          x;
      for (x in info) {
        var el = findByClass(rootElement, x);
        if (el) {
          el.innerHTML = info[x];
        }
      }

      var search = table.searchText || "";
      var searchEl = findByClass(rootElement, "search-field");
      // update the search element value, but only if it is not currently
      // focused. Because if it is focused, the user is using it.
      if (searchEl && searchEl.value != search && _dom2.default.isFocused(searchEl) == false) {
        searchEl.value = search;
      }

      return this;
    }

    /**
     * Updates the table view to the current table state.
     */

  }, {
    key: "updateView",
    value: function updateView() {
      var self = this,
          o = self.options,
          table = self.table,
          data = table.pagination,
          rootElement = self.rootElement;
      if (!rootElement) {
        (0, _raise2.default)(26, "missing root element");
      }

      // classes
      _utils2.default.each({
        "kt-search-active": table.searchText,
        "kt-search-sorting": table.options.searchSortingRules
      }, function (condition, key) {
        _dom2.default.modClass(rootElement, key, condition);
      });

      // get data to display
      var data = table.getData({
        format: true,
        hide: false
      });
      var viewEl = _dom2.default.findFirstByClass(rootElement, "king-table-view");
      if (!data || !data.length) {
        // display empty view inside the table view region
        viewEl.innerHTML = self.emptyView().toString();
        return self;
      }
      var columns = self.getFields();
      // do tools need to be built for the first time?
      // TODO: eventually, support reinitializing columns (current implementation supports only tables that do not change between ajax requests)
      if (self._must_build_tools) {
        // get element
        var toolsEl = document.getElementById(self.toolsRegionId);
        toolsEl.innerHTML = self.buildToolsInner(true);
        delete self._must_build_tools;
      }
      self.currentItems = data;
      var view = self.buildView(columns, data);
      viewEl.innerHTML = view.children[0].toString();
      _utils2.default.ifcall(o.onViewUpdate, self, [viewEl]); // call if exists
      return self;
    }

    /**
     * Displays a built table.
     */

  }, {
    key: "display",
    value: function display(built) {
      var table = this.table,
          o = this.options;
      // if a table has an element, assume that is a DOM element;
      if (!_utils2.default.isString(built)) built = built.toString();
      this.ensureLayout();
      var root = this.rootElement;
      // update view only
      var viewEl = _dom2.default.findFirstByClass(root, "king-table-view");
      viewEl.innerHTML = built;
      _utils2.default.ifcall(o.onViewUpdate, this, [viewEl]); // call if exists
    }

    /**
     * Builds a root virtual element for the given table, with given
     * table children.
     */

  }, {
    key: "buildRoot",
    value: function buildRoot(caption, view) {
      var table = this.table;
      var rootAttr = {
        "class": "king-table-region"
      };
      if (table.id) {
        rootAttr.id = table.id;
      }
      return new _html.VHtmlElement("div", rootAttr, [caption, this.buildPaginationBar(), this.buildFiltersView(), view]);
    }

    /**
     * Builds a header from given table and columns.
     *
     * @param {object[]} columns;
     * @param {object[]} data;
     */

  }, {
    key: "buildPaginationBar",
    value: function buildPaginationBar() {
      var table = this.table,
          reg = this.getReg(),
          o = this.options,
          data = table.pagination,
          page = data.page,
          totalPageCount = data.totalPageCount,
          resultsPerPage = data.resultsPerPage,
          firstObjectNumber = data.firstObjectNumber,
          lastObjectNumber = data.lastObjectNumber,
          totalItemsCount = data.totalItemsCount,
          filtersView = o.filtersView,
          filtersViewExpandable = filtersView && o.filtersViewExpandable,
          filtersViewOpen = filtersViewExpandable && o.filtersViewOpen,
          dataAnchorTime = table.getFormattedAnchorTime(),
          isNum = _utils2.default.isNumber;

      var resultsInfo = "";
      if (isNum(firstObjectNumber) && isNum(lastObjectNumber) && lastObjectNumber > 0) {
        resultsInfo += reg.results + (" " + firstObjectNumber + " - " + lastObjectNumber);
        if (isNum(totalItemsCount)) {
          resultsInfo += " " + reg.of + " - " + totalItemsCount;
        }
      }
      var anchorTimeInfo;
      if (dataAnchorTime && table.options.showAnchorTimestamp) {
        anchorTimeInfo = reg.anchorTime + " " + dataAnchorTime;
      }
      var advancedFilters = reg.advancedFilters;
      var searchElement = o.allowSearch ? new _html.VHtmlElement("span", {
        "class": "pagination-bar-filters"
      }, new _html.VHtmlElement("input", {
        "type": "text",
        "class": "search-field",
        "value": table.searchText || ""
      })) : null;
      var span = "span",
          separator = new _html.VHtmlElement(span, { "class": "separator" });
      return new _html.VHtmlElement("div", {
        "class": "pagination-bar"
      }, [this.buildTools(), new _html.VHtmlElement(span, { "class": "pagination-bar-buttons" }, [new _html.VHtmlElement(span, {
        "tabindex": "0",
        "class": "pagination-button pagination-bar-first-page oi",
        "data-glyph": "media-step-backward",
        "title": reg.firstPage
      }), new _html.VHtmlElement(span, {
        "tabindex": "0",
        "class": "pagination-button pagination-bar-prev-page oi",
        "data-glyph": "caret-left",
        "title": reg.prevPage
      }), separator, new _html.VHtmlElement(span, {
        "class": "valigned"
      }, new _html.VTextElement(reg.page)), new _html.VHtmlElement("input", {
        "type": "text",
        "name": "page-number",
        "class": "must-integer pagination-bar-page-number",
        "value": data.page
      }), new _html.VHtmlElement("span", {
        "class": "valigned total-page-count",
        "value": data.page
      }, new _html.VTextElement(reg.of + " " + data.totalPageCount)), separator, new _html.VHtmlElement(span, {
        "tabindex": "0",
        "class": "pagination-button pagination-bar-refresh oi",
        "data-glyph": "reload",
        "title": reg.refresh
      }), separator, new _html.VHtmlElement(span, {
        "tabindex": "0",
        "class": "pagination-button pagination-bar-next-page oi",
        "data-glyph": "caret-right",
        "title": reg.nextPage
      }), new _html.VHtmlElement(span, {
        "tabindex": "0",
        "class": "pagination-button pagination-bar-last-page oi",
        "data-glyph": "media-step-forward",
        "title": reg.lastPage
      }), separator, new _html.VHtmlElement(span, {
        "class": "valigned"
      }, new _html.VTextElement(reg.resultsPerPage)), new _html.VHtmlElement("select", {
        "name": "pageresults",
        "class": "pagination-bar-results-select valigned"
      }, _utils2.default.map(o.resultsPerPageSelect, function (x) {
        var a = new _html.VHtmlElement("option", {
          "value": x
        }, new _html.VTextElement(x.toString()));
        if (x === o.resultsPerPage) {
          a.attributes.selected = true;
        }
        return a;
      })), separator, resultsInfo ? new _html.VHtmlElement(span, {
        "class": "valigned results-info"
      }, new _html.VTextElement(resultsInfo)) : null, resultsInfo ? separator : null, anchorTimeInfo ? new _html.VHtmlElement(span, {
        "class": "valigned anchor-timestamp-info"
      }, new _html.VTextElement(anchorTimeInfo)) : null, searchElement ? separator : null, searchElement, filtersViewExpandable ? separator : null, filtersViewExpandable ? new _html.VHtmlElement("button", {
        "class": "btn valigned camo-btn kt-advanced-filters" + (filtersViewOpen ? " kt-open" : "")
      }, new _html.VTextElement(advancedFilters)) : null])]);
    }

    /**
     * Builds a header from given table and columns.
     *
     * @param {object[]} columns;
     * @param {object[]} data;
     */

  }, {
    key: "buildHead",
    value: function buildHead(columns) {
      var table = this.table;
      var builder = table.builder;
      var sortCriteria = table.sortCriteria,
          reg = builder.getReg();
      var row = new _html.VHtmlElement("tr", {}, _utils2.default.map(_utils2.default.values(columns), function (prop) {
        if (prop.hidden || prop.secret) {
          return; // skip
        }
        var sorting = false,
            order,
            classes = [prop.css];
        if (prop.sortable) {
          classes.push("sortable");
          // is the table currently sorted by this property?
          var sortedBy = _utils2.default.find(sortCriteria, function (x) {
            return x[0] === prop.name;
          });
          if (sortedBy) {
            sorting = true;
            order = sortedBy[1];
          }
        }
        var displayName = prop.displayName;
        var cell = new _html.VHtmlElement("th", { "class": classes.join(" "), "data-prop": prop.name }, new _html.VHtmlElement("div", {}, [new _html.VHtmlElement("span", {}, new _html.VTextElement(displayName)), sorting ? new _html.VHtmlElement("span", {
          "class": "oi kt-sort-glyph",
          "data-glyph": order == 1 ? "sort-ascending" : "sort-descending",
          "aria-hidden": true,
          "title": _utils2.default.format(order == 1 ? reg.sortAscendingBy : reg.sortDescendingBy, { name: displayName })
        }) : null]));

        return cell;
      }));
      return new _html.VHtmlElement("thead", { "class": "king-table-head" }, row);
    }

    /**
     * Builds a view for the given table.
     *
     * @param {KingTable} table;
     * @param {object[]} columns;
     * @param {object[]} data;
     */

  }, {
    key: "buildView",
    value: function buildView(columns, data, subView) {
      var table = this.table;
      var view;
      if (subView) {
        view = subView;
      } else if (!data || !data.length) {
        view = new _html.VHtmlElement("div", {
          "class": "king-table-view"
        }, this.emptyView());
      } else {
        var resolver = this.getViewResolver(),
            view;
        if (resolver === this) {
          // use default resolver
          view = new _html.VHtmlElement("table", {
            "class": "king-table"
          }, [this.buildHead(columns), this.buildBody(columns, data)]);
        } else {
          // use custom resolver
          // add reference to table and options
          resolver.table = this.table;
          resolver.options = table.options;

          view = resolver.buildView(table, columns, data);
          // remove reference
          delete resolver.table;
          delete resolver.options;
        }
      }
      // wrap in view root element
      return new _html.VHtmlElement("div", {
        "class": "king-table-view"
      }, view);
    }
  }, {
    key: "getTemplate",
    value: function getTemplate(option, type) {
      if (_utils2.default.isFunction(option)) {
        return option.call(this);
      }
      if (!_utils2.default.isString(option)) {
        (0, _raise2.default)(38, "Cannot obtain HTML from given parameter " + type + ", must be a function or a string.");
      }
      var element = document.getElementById(option);
      if (element != null) {
        if (/script/i.test(element.tagName)) {
          return element.innerText;
        }
        (0, _raise2.default)(38, "Cannot obtain HTML from parameter " + type + ". Element is not <script>.");
      }
      // option treated as html fragment itself
      return option;
    }

    /**
     * Builds a filters view for the given table.
     */

  }, {
    key: "buildFiltersView",
    value: function buildFiltersView() {
      var self = this,
          o = self.options,
          filtersView = o.filtersView;

      if (!filtersView) return;
      var filtersViewOpen = o.filtersViewOpen,
          filtersViewExpandable = o.filtersViewExpandable,
          template = self.getTemplate(filtersView, "filtersView"),
          css = ["kt-filters"];

      if (filtersViewOpen || !filtersViewExpandable) css.push("kt-open");
      if (filtersViewExpandable) css.push("kt-expandable");

      return new _html.VHtmlElement("div", {
        "class": css.join(" ")
      }, [new _html.VHtmlFragment(template)]);
    }

    /**
     * Builds a tools view for the given table.
     */

  }, {
    key: "buildTools",
    value: function buildTools() {
      // tools can be either built immediately (if columns information are ready);
      // or afterwards upon update
      var table = this.table,
          colsInitialized = table.columnsInitialized;
      if (!colsInitialized) {
        this._must_build_tools = true;
      }
      var _id = this.toolsRegionId = _utils2.default.uniqueId("tools-region");
      return new _html.VHtmlElement("div", {
        "id": _id,
        "class": "tools-region"
      }, this.buildToolsInner(colsInitialized));
    }
  }, {
    key: "buildToolsInner",
    value: function buildToolsInner(colsInitialized) {
      return new _html.VWrapperElement([new _html.VHtmlElement("span", {
        "class": "oi ug-expander",
        "tabindex": "0",
        "data-glyph": "cog"
      }), colsInitialized ? this.buildMenu() : null]);
    }
  }, {
    key: "buildMenu",
    value: function buildMenu() {
      var self = this,
          o = self.options,
          extraTools = o.tools;

      var tools = [self.getColumnsMenuSchema(), self.getViewsMenuSchema(), o.allowSortModes ? self.getSortModeSchema() : null, self.getExportMenuSchema()];

      if (extraTools) {
        if (_utils2.default.isFunction(extraTools)) extraTools = extraTools.call(this);
        if (extraTools) {
          if (!_utils2.default.isArray(extraTools)) {
            (0, _raise2.default)(40, "Tools is not an array or a function returning an array.");
          }
          tools = tools.concat(extraTools);
        }
      }

      if (o.prepTools) {
        if (!_utils2.default.isFunction(o.prepTools)) {
          (0, _raise2.default)(41, "prepTools option must be a function.");
        }
        o.prepTools.call(this, tools);
      }

      return (0, _kingtableMenu.menuBuilder)({
        items: tools
      });
    }
  }, {
    key: "getSortModeSchema",
    value: function getSortModeSchema() {
      var reg = this.getReg();
      var options = this.options,
          currentMode = options.sortMode;
      var items = _utils2.default.map(SortModes, function (key, value) {
        return {
          name: reg.sortModes[value],
          checked: currentMode == value,
          type: "radio",
          value: value, // this is the radio value; and is required
          attr: {
            "name": "kt-sort-mode",
            "class": "sort-mode-radio"
          }
        };
      });
      return {
        name: reg.sortOptions,
        menu: {
          items: items
        }
      };
    }

    /**
     * Builds a default schema for columns menu.
     */

  }, {
    key: "getColumnsMenuSchema",
    value: function getColumnsMenuSchema() {
      // TODO: allow to disable by configuration
      if (!this.table.columns || !this.table.columns.length) {
        throw "Columns not initialized.";
      }
      var columns = _utils2.default.where(this.table.columns, function (x) {
        return !x.secret;
      });
      var reg = this.getReg();
      return {
        name: reg.columns,
        menu: {
          items: _utils2.default.map(columns, function (x) {
            return {
              name: x.displayName,
              checked: !x.hidden,
              type: CHECKBOX_TYPE,
              attr: {
                "name": x.name,
                "class": "visibility-check"
              }
            };
          })
        }
      };
    }

    /**
     * Builds a default schema for views menu.
     */

  }, {
    key: "getViewsMenuSchema",
    value: function getViewsMenuSchema() {
      var reg = this.getReg();
      var o = this.options,
          views = o.views,
          currentView = o.view;
      var items = _utils2.default.map(views, function (o) {
        var value = o.name;
        return {
          name: reg.viewsType[value] || value,
          checked: currentView == value,
          type: "radio",
          value: value,
          attr: {
            "name": "kt-view-type",
            "class": "view-type-radio"
          }
        };
      });
      return {
        name: reg.view,
        menu: {
          items: items
        }
      };
    }

    /**
     * Builds a default schema for export tools.
     */

  }, {
    key: "getExportMenuSchema",
    value: function getExportMenuSchema() {
      var table = this.table,
          exportFormats = table.options.exportFormats;
      if (!exportFormats || !exportFormats.length) return null; // disabled
      // if the client does not support client side export, remove the client side export formats
      if (!_file2.default.supportsCsExport()) {
        exportFormats = _utils2.default.reject(exportFormats, function (o) {
          return o.cs || o.clientSide;
        });
      }
      if (!exportFormats || !exportFormats.length) return null; // disabled

      var reg = this.getReg();

      var items = _utils2.default.map(exportFormats, function (o) {
        return {
          name: reg.exportFormats[o.format] || o.name,
          attr: {
            css: "export-btn",
            "data-format": o.format
          }
        };
      });

      return {
        name: reg.export,
        menu: {
          items: items
        }
      };
    }
  }, {
    key: "goToPrev",
    value: function goToPrev() {
      this.table.pagination.prev();
    }
  }, {
    key: "goToNext",
    value: function goToNext() {
      this.table.pagination.next();
    }
  }, {
    key: "goToFirst",
    value: function goToFirst() {
      this.table.pagination.first();
    }
  }, {
    key: "goToLast",
    value: function goToLast() {
      this.table.pagination.last();
    }
  }, {
    key: "refresh",
    value: function refresh() {
      this.table.refresh();
    }
  }, {
    key: "changePage",
    value: function changePage(e) {
      var v = e.target.value;
      if (/^\d+$/.test(v) && this.table.pagination.validPage(parseInt(v))) {
        // update
        this.table.pagination.page = parseInt(v);
        this.table.render();
      } else {
        // revert value
        e.target.value = this.table.pagination.page;
      }
    }
  }, {
    key: "changeResultsNumber",
    value: function changeResultsNumber(e) {
      var v = e.target.value;
      this.table.pagination.resultsPerPage = parseInt(v);
      this.table.render();
    }

    /**
     * Obtains the item related to the given event.
     * 
     * @param Event e: event
     */

  }, {
    key: "getItemByEv",
    value: function getItemByEv(e, ignoreMissing) {
      if (!e) return;
      return this.getItemByEl(e.target, ignoreMissing);
    }

    /**
     * Obtains the item to which a given HTML pertains.
     * 
     * @param HTMLElement el: element
     */

  }, {
    key: "getItemByEl",
    value: function getItemByEl(el, ignoreMissing) {
      if (!el) return;
      var itemElement = _dom2.default.closestWithClass(el, "kt-item");
      if (!itemElement) {
        // the element is not contained in an kt-item
        if (ignoreMissing) return;
        // not what the user of the library wants
        (0, _raise2.default)(36, "Cannot retrieve an item by event data. Make sure that HTML elements generated for table items have 'kt-item' class.");
      }
      var itemIx = itemElement.dataset.itemIx;
      if (_utils2.default.isUnd(itemIx)) {
        (0, _raise2.default)(37, "Cannot retrieve an item by element data. Make sure that HTML elements generated for table items have 'data-ix' attribute.");
      }
      return this.currentItems[itemIx]; //_.find(this.currentItems, i => i.__ix__ == itemIx);
    }
  }, {
    key: "onItemClick",
    value: function onItemClick(e) {
      var item = this.getItemByEl(e.target),
          options = this.options,
          pure = options.purist,
          und;
      options.onItemClick.call(this, item, pure ? und : e);
    }
  }, {
    key: "toggleAdvancedFilters",
    value: function toggleAdvancedFilters() {
      var name = "filtersViewOpen",
          oc = "kt-open";
      var filtersView = _dom2.default.findByClass(this.rootElement, "kt-filters")[0];
      var open = _dom2.default.hasClass(filtersView, oc);
      this[name] = !open;
      _dom2.default.modClass(filtersView, oc, this[name]);
    }
  }, {
    key: "clearFilters",
    value: function clearFilters() {
      // TODO
    }
  }, {
    key: "sort",
    value: function sort(e) {
      var el = e.target,
          options = this.options;
      // if sorting by search, ignore
      if (this.table.searchText && options.searchSortingRules) {
        return true;
      }

      if (!/th/i.test(el.tagName)) {
        el = _dom2.default.closestWithTag(el, "th");
      }
      var property = el.dataset.prop,
          table = this.table;;
      if (property && _utils2.default.any(this.table.columns, function (x) {
        return x.name == property;
      })) {
        switch (options.sortMode) {
          case SortModes.Simple:
            // sort by single property
            table.progressSortBySingle(property);
            break;
          case SortModes.Complex:
            // sort by multiple properties, in order of definition
            table.progressSortBy(property);
            break;
          default:
            (0, _raise2.default)(28, "Invalid sort mode options. Value must be either 'simple' or 'complex'.");
        }
      }
    }
  }, {
    key: "onSearchKeyUp",
    value: function onSearchKeyUp(e) {
      var a = e.target.value;
      this.search(a);
    }
  }, {
    key: "onSearchChange",
    value: function onSearchChange(e) {
      var a = e.target.value;
      this.search(a);
    }
  }, {
    key: "viewToModel",
    value: function viewToModel() {
      console.log("TODO");
    }
  }, {
    key: "prepareEvents",
    value: function prepareEvents(events, purist) {
      if (!events) return;
      if (_utils2.default.isFunction(events)) events = events.call(this);
      var x,
          newObj = {};

      var _loop = function _loop() {
        var fn = events[x];
        newObj[x] = _utils2.default.isString(fn) ? fn : function (e) {
          var item = this.getItemByEv(e, true);
          if (purist) {
            var re = fn.call(this, item);
          } else {
            var re = fn.call(this, e, item);
          }
          return re === false ? false : true;
        };
      };

      for (x in events) {
        _loop();
      }
      return newObj;
    }
  }, {
    key: "getEvents",
    value: function getEvents() {
      var options = this.options,
          purist = options.purist,
          events = options.events,
          ievents = options.ievents;
      // wrap custom events to receive the item as first parameter (if available), and maybe the event
      events = this.prepareEvents(events, purist);
      ievents = this.prepareEvents(ievents, true);
      var baseevents = this.getBaseEvents();
      return _utils2.default.extend({}, baseevents, events, ievents);
    }
  }, {
    key: "setSortMode",
    value: function setSortMode(name) {
      this.options.sortMode = name;
      // store sort mode in memory;
      this.table.storePreference("sort-mode", name);
    }
  }, {
    key: "setViewType",
    value: function setViewType(name) {
      this.options.view = name;
      // store sort mode in memory;
      this.table.storePreference("view-type", name);
      this.table.render();
    }
  }, {
    key: "getColumnsVisibility",
    value: function getColumnsVisibility() {
      var columnsCheckbox = _dom2.default.findByClass(this.rootElement, "visibility-check");
      return _utils2.default.map(columnsCheckbox, function (x) {
        return { name: _dom2.default.attr(x, "name"), visible: x.checked };
      });
    }

    /**
     * Event handler for default columns visibility checkbox change.
     */

  }, {
    key: "onColumnVisibilityChange",
    value: function onColumnVisibilityChange() {
      var columnsVisibility = this.getColumnsVisibility();
      this.table.toggleColumns(columnsVisibility);
    }
  }, {
    key: "onViewChange",
    value: function onViewChange(e) {
      if (!e) return true;
      var target = e.target;
      this.setViewType(target.value);
    }
  }, {
    key: "onSortModeChange",
    value: function onSortModeChange(e) {
      if (!e) return true;
      var target = e.target;
      this.setSortMode(target.value);
    }
  }, {
    key: "onExportClick",
    value: function onExportClick(e) {
      var el = e.target,
          format = el.dataset.format;
      if (!format) {
        (0, _raise2.default)(29, "Missing format in export element's dataset.");
      }
      this.table.exportTo(format);
    }
  }, {
    key: "getBaseEvents",
    value: function getBaseEvents() {
      var baseevents = {
        "click .pagination-bar-first-page": "goToFirst",
        "click .pagination-bar-last-page": "goToLast",
        "click .pagination-bar-prev-page": "goToPrev",
        "click .pagination-bar-next-page": "goToNext",
        "click .pagination-bar-refresh": "refresh",
        "change .pagination-bar-page-number": "changePage",
        "change .pagination-bar-results-select": "changeResultsNumber",
        "click .kt-advanced-filters": "toggleAdvancedFilters",
        "click .btn-clear-filters": "clearFilters",
        "click .king-table-head th.sortable": "sort",
        "keyup .search-field": "onSearchKeyUp",
        "paste .search-field, cut .search-field": "onSearchChange",
        "keyup .filters-region input[type='text']": "viewToModel",
        "keyup .filters-region textarea": "viewToModel",
        "change .filters-region input[type='checkbox']": "viewToModel",
        "change .filters-region input[type='radio']": "viewToModel",
        "change .filters-region select": "viewToModel",
        "change .visibility-check": "onColumnVisibilityChange",
        "click .export-btn": "onExportClick",
        "change [name='kt-view-type']": "onViewChange",
        "change [name='kt-sort-mode']": "onSortModeChange"
      };
      // different input types
      _utils2.default.each("text date datetime datetime-local email tel time search url week color month number".split(" "), function (inputType) {
        baseevents["change .filters-region input[type='" + inputType + "']"] = "viewToModel";
      });
      var options = this.options;
      if (options.onItemClick) {
        baseevents["click .kt-item"] = "onItemClick";
      }
      return baseevents;
    }
  }, {
    key: "bindEvents",
    value: function bindEvents() {
      var a = "__events__bound";
      if (this[a]) return this;
      this[a] = 1;
      return this.delegateEvents().bindWindowEvents();
    }
  }, {
    key: "anyMenuIsOpen",
    value: function anyMenuIsOpen() {
      return false; // TODO
    }
  }, {
    key: "bindWindowEvents",
    value: function bindWindowEvents() {
      if (typeof window != "undefined") {
        var self = this.unbindWindowEvents();
        _dom2.default.on(document.body, "keydown.king-table", function (e) {
          //if any menu is open, or any input is focused, do nothing
          if (_dom2.default.anyInputFocused() || self.anyMenuIsOpen()) return true;
          var kc = e.keyCode;
          //if the user clicked the left arrow, or A, go to previous page
          if (_utils2.default.contains([37, 65], kc)) {
            //prev page
            self.goToPrev();
          }
          //if the user clicked the right arrow, or D, go to next page
          if (_utils2.default.contains([39, 68], kc)) {
            //next page
            self.goToNext();
          }
        });
      }
      //TODO: support swipe events; using HammerJs library
      return this;
    }
  }, {
    key: "unbindWindowEvents",
    value: function unbindWindowEvents() {
      if (typeof window != "undefined") {
        var self = this;
        _dom2.default.off(document.body, "keydown.king-table");
      }
      return this;
    }

    /**
     * Applies event handlers.
     */

  }, {
    key: "delegateEvents",
    value: function delegateEvents() {
      var self = this,
          table = self.table,
          options = self.options,
          root = self.table.element,
          events = self.getEvents(),
          delegateEventSplitter = /^(\S+)\s*(.*)$/;
      self.undelegateEvents();
      for (var key in events) {
        var val = events[key],
            method = val;
        if (!method) (0, _raise2.default)(27, "Invalid method definition");
        // if method try to read from builder itself
        if (!_utils2.default.isFunction(method)) method = self[method];
        if (!method && _utils2.default.isFunction(options[val]))
          // try to read from options
          method = options[val];

        if (!_utils2.default.isFunction(method)) throw new Error("method not defined inside the model: " + events[key]);
        var match = key.match(delegateEventSplitter);
        var eventName = match[1],
            selector = match[2];
        method = _utils2.default.bind(method, self);
        eventName += ".delegate";
        if (selector === "") {
          // TODO: support
          throw new Error("delegates without selector are not implemented");
        } else {
          _dom2.default.on(root, eventName, selector, method);
        }
      }
      var a = "__events__bound";
      self[a] = 0;
      return self;
    }

    /**
     * Clears all event handlers associated with this table builder.
     */

  }, {
    key: "undelegateEvents",
    value: function undelegateEvents() {
      _dom2.default.off(this.table.element);
      return this;
    }

    /**
     * Disposes of this KingTableRichHtmlBuilder.
     */

  }, {
    key: "dispose",
    value: function dispose() {
      // undelegate events
      this.undelegateEvents().unbindWindowEvents();
      // remove element
      _dom2.default.remove(this.rootElement);
      _dom2.default.removeClass(this.table.element, KingTableClassName);

      // removes reference to root element (it gets removed from DOM inside base dispose)
      this.currentItems = this.rootElement = null;
      _get(KingTableRichHtmlBuilder.prototype.__proto__ || Object.getPrototypeOf(KingTableRichHtmlBuilder.prototype), "dispose", this).call(this);
    }
  }, {
    key: "emptyView",
    value: function emptyView() {
      var reg = this.getReg();
      return new _html.VHtmlElement("div", { "class": "king-table-empty" }, new _html.VHtmlElement("span", 0, new _html.VTextElement(reg.noData)));
    }
  }, {
    key: "errorView",
    value: function errorView(message) {
      if (!message) {
        message = this.getReg().errorFetchingData;
      }
      return new _html.VHtmlFragment("<div class=\"king-table-error\">\n      <span class=\"message\">\n        <span>" + message + "</span>\n        <span class=\"oi\" data-glyph=\"warning\" aria-hidden=\"true\"></span>\n      </span>\n    </div>");
    }
  }, {
    key: "loadingView",
    value: function loadingView() {
      var reg = this.getReg();
      return new _html.VHtmlElement("div", {
        "class": "loading-info"
      }, [new _html.VHtmlElement("span", {
        "class": "loading-text"
      }, new _html.VTextElement(reg.loading)), new _html.VHtmlElement("span", {
        "class": "mini-loader"
      })]);
    }
  }, {
    key: "singleLine",
    value: function singleLine() {
      throw new Error("make targeted updates");
    }
  }], [{
    key: "BaseHtmlBuilder",
    get: function get() {
      return _kingtableHtmlBase2.default;
    }
  }, {
    key: "DomUtils",
    get: function get() {
      return _dom2.default;
    }
  }]);

  return KingTableRichHtmlBuilder;
}(_kingtableHtml2.default);

KingTableRichHtmlBuilder.defaults = {
  view: "table",
  views: [{ name: "table", resolver: true }, { name: "gallery", resolver: KingTableRhGalleryViewResolver }],
  filtersView: null, // allows to define a view for advanced filters
  filtersViewExpandable: true, // whether the advanced filters view should be expandable; or always visible.
  filtersViewOpen: false, // whether filters view should be automatically displayed, upon table render.
  searchDelay: 50,
  sortMode: SortModes.Simple,
  allowSortModes: true, // whether to allow selecting sort mode
  purist: false, // whether to exclude event and other DOM data in high level callbacks

  // Permits to specify the options of the results per page select
  resultsPerPageSelect: [10, 30, 50, 100, 200],

  // Permits to specify extra tools for this table
  tools: null,

  // Allows to alter tools before render
  prepTools: null,

  // Whether to automatically highlight values that answer to text search criteria.
  autoHighlightSearchProperties: true
};

exports.default = KingTableRichHtmlBuilder;