"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require("../scripts/components/events");

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Tests for EventsEmitter class.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://github.com/RobertoPrevato/KingTable
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018, Roberto Prevato
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://robertoprevato.github.io
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the MIT license:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * http://www.opensource.org/licenses/MIT
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Cat = function (_EventsEmitter) {
  _inherits(Cat, _EventsEmitter);

  function Cat() {
    _classCallCheck(this, Cat);

    return _possibleConstructorReturn(this, (Cat.__proto__ || Object.getPrototypeOf(Cat)).call(this));
  }

  return Cat;
}(_events2.default);

;

var Dog = function (_EventsEmitter2) {
  _inherits(Dog, _EventsEmitter2);

  function Dog() {
    _classCallCheck(this, Dog);

    return _possibleConstructorReturn(this, (Dog.__proto__ || Object.getPrototypeOf(Dog)).call(this));
  }

  _createClass(Dog, [{
    key: "bark",
    value: function bark() {
      this.trigger("bark");
    }
  }]);

  return Dog;
}(_events2.default);

var CACHE = {
  meow: 0,
  meowzz: 0
};

describe("EventsEmitter class", function () {

  it("must support custom event handlers", function () {
    var cat = new Cat();
    cat.on("meow", function () {
      CACHE.meow++;
    });

    cat.trigger("meow");
    expect(CACHE.meow).toEqual(1);

    cat.trigger("meow");
    expect(CACHE.meow).toEqual(2);
  });

  it("must support once event handlers", function () {
    var cat = new Cat();

    cat.once("meowzz", function () {
      CACHE.meowzz++;
    });

    cat.trigger("meowzz");
    expect(CACHE.meowzz).toEqual(1);

    cat.trigger("meowzz");
    expect(CACHE.meowzz).toEqual(1);

    cat.trigger("meowzz");
    expect(CACHE.meowzz).toEqual(1);
  });

  it("must allow to listen other events transmitters", function () {
    var cat = new Cat(),
        dog = new Dog(),
        n = 0;

    cat.listenTo(dog, "bark", function () {
      expect(this).toEqual(cat);
      cat.trigger("run");
      n++;
    });

    dog.trigger("bark");
    expect(n).toEqual(1);

    dog.trigger("bark");
    expect(n).toEqual(2);
  });

  it("must allow to listen other events transmitters", function () {
    var cat = new Cat(),
        dog = new Dog(),
        n = 0;

    // NB: context is respected only if using function () { } syntax
    cat.listenToOnce(dog, "bark", function () {
      expect(this).toEqual(cat);
      cat.trigger("run");
      n++;
    });

    dog.trigger("bark");
    expect(n).toEqual(1);

    dog.trigger("bark");
    expect(n).toEqual(1);

    dog.trigger("bark");
    expect(n).toEqual(1);
  });
});